SUBROUTINE albedo_compute(solel,diffuse_frac,cloud_frac,r_vis,r_nir,a)
USE params
USE nrtype
IMPLICIT NONE

	REAL(DP),			INTENT(IN   )		:: solel
	REAL(DP),			INTENT(IN   )		:: diffuse_frac
	REAL(DP),			INTENT(IN   )		:: cloud_frac
	REAL(DP),			INTENT(IN   )		:: r_vis
	REAL(DP),			INTENT(IN   )		:: r_nir
	REAL(DP),			INTENT(  OUT)		:: a

	REAL(DP)								:: a_vis_dif
	REAL(DP)								:: a_nir_dif
	REAL(DP)								:: a_vis_dir
	REAL(DP)								:: a_nir_dir
	REAL(DP)								:: a_nir
	REAL(DP)								:: a_vis
	REAL(DP)								:: f_vis


		a_vis_dif=a_vis_max-kappa_vis*r_vis
		a_nir_dif=a_nir_max*EXP(-kappa_nir*r_nir)
		a_vis_dir=a_vis_dif+kappa_vis_theta*r_vis*(1/SQRT(3._dp)-SIN(solel))
		a_nir_dir=a_nir_dif+(kappa_nir_theta*r_nir+0.1)*(1/SQRT(3._dp)-SIN(solel))
		a_vis=a_vis_dif*diffuse_frac+a_vis_dir*(1._dp-diffuse_frac)
		a_nir=a_nir_dif*diffuse_frac+a_nir_dir*(1._dp-diffuse_frac)
		f_vis=0.5+0.149*(1-cloud_frac)!This is the visible SW radiation fraction
		a=a_vis*(f_vis)+a_nir*(1._dp-f_vis)

END SUBROUTINE albedo_compute