SUBROUTINE bilinterp(zgrid,x,y,minx,maxx,miny,maxy,zinterp)
USE params
USE nrtype

	
	REAL(DP), DIMENSION(nlat,nlong), 	INTENT(IN   )	:: zgrid
	REAL(DP), 				INTENT(IN   )	:: x,y
	INTEGER(I4B), 				INTENT(IN   )	:: minx,maxx,miny,maxy
	REAL(DP),				INTENT(  OUT)	:: zinterp
	REAL(DP) 						:: t,u
	
	!IF ((ABS(x-REAL(minx)) .LT. 0.001_dp) .OR. (ABS(x-REAL(maxx)) .LT. 0.001_dp) .OR. &
	!   (ABS(y-REAL(miny)) .LT. 0.001_dp) .OR. (ABS(y-REAL(maxy)) .LT. 0.001_dp)) THEN
	!    IF (ABS(x-REAL(minx)) .LT. 0.001_dp) THEN
	!        u=0._dp
	!    ELSE
	!        u=(x-minx)/(maxx-minx)
	!    ENDIF
	!    IF (ABS(REAL(maxx)-x) .LT. 0.001_dp) THEN
	!        u=1._dp
    !    ELSE
    !        u=(x-minx)/(maxx-minx)
    !    ENDIF
	!    IF (ABS(y-REAL(miny)) .LT. 0.001_dp) THEN
	!        t=0._dp
	!    ELSE
	!        t=(y-miny)/(maxy-miny)
	!    ENDIF
	!    IF (ABS(REAL(maxy)-y) .LT. 0.001_dp) THEN
	!        t=1._dp
	!    ELSE
	!        t=(y-miny)/(maxy-miny)
	!    ENDIF
	!ELSE	
	    u=(x-minx)/(maxx-minx)
	    t=(y-miny)/(maxy-miny)
		IF (u .LT. 0._dp) u=0._dp
		IF (u .GT. 1._dp) u=1._dp
		IF (t .LT. 0._dp) t=0._dp
		IF (t .GT. 1._dp) t=0._dp
	!END IF		
	!zinterp=(1-u)*(1-t)*zgrid(miny,minx)+u*(1-t)*zgrid(maxy,minx)+ &
	!	u*t*zgrid(maxy,maxx)+(1-u)*t*zgrid(miny,maxx)
	zinterp=(1-t)*(1-u)*zgrid(miny,minx)+t*(1-u)*zgrid(maxy,minx)+ &
		t*u*zgrid(maxy,maxx)+(1-t)*u*zgrid(miny,maxx)
END SUBROUTINE bilinterp
