SUBROUTINE getdata(bdem,gdem,giss_topography,S,A,meanhangle,shading,trans_coeff_snow,trans_coeff_ice,latgrid,longrid)
USE params
USE nrtype
IMPLICIT NONE

!***************************************************************************************
!*	This subroutine opens and reads in data from the met file as well as the output
!*	from the terrain pre-processor.
!*



	REAL(DP),   DIMENSION(1:nlat,1:nlong),		INTENT(  OUT)	:: bdem,gdem,giss_topography,S,A,meanhangle,latgrid,longrid
	REAL(DP),   DIMENSION(1:nlat,1:nlong,1:36),	INTENT(  OUT)	:: shading
	REAL(DP),	DIMENSION(80,200),			INTENT(  OUT)	:: trans_coeff_snow,trans_coeff_ice
	REAL(DP),	DIMENSION(:,:,:),			ALLOCATABLE		:: trans_coeff


        INTEGER (I4B)							:: i,j,k,l,ios,round,roughindex, trash

	CHARACTER(LEN=4)						:: header
	CHARACTER(LEN=30)						:: filenumber, filename

	ALLOCATE(trans_coeff(80,200,400))


	CLOSE(UNIT=11)
	!***********************************************************************************
	!**		Time to read in the met files for the
	!**		Laurentide ice sheet.
	!**		These are going to go into a 4D grid that will
	!**		have dimensions of x,y,day,variable
	!**		the days will start at jan 1 and the variable
	!**		order will be temp, rh, insol, longwave, wind, precip.
	!**		The output met variable is called 'var'.
	!***********************************************************************************

	!Open up the 6 files that contain input met data for the model
!	OPEN (UNIT=31,FILE=inputstr//'temp_scaled.txt',STATUS='old')
!	OPEN (UNIT=32,FILE=inputstr//'rh_scaled.txt',STATUS='old')
!	OPEN (UNIT=33,FILE=inputstr//'sw_scaled.txt',STATUS='old')
!	OPEN (UNIT=34,FILE=inputstr//'lw_scaled.txt',STATUS='old')
!	OPEN (UNIT=35,FILE=inputstr//'wind_scaled.txt',STATUS='old')
!	OPEN (UNIT=36,FILE=inputstr//'prec_scaled.txt',STATUS='old')
!	DO l=31,(30+ninsts),1	!loop through the instrument files
!		DO i=1,365,1		!Loop through the days in the temp record
!			DO j=1,nlat,1	!loop through the rows
!				READ(UNIT=(l),FMT=*) (var(j,k,i,(l-30)),k=1,nlong,1)
!			ENDDO
!		ENDDO
!		CLOSE(UNIT=l)
!	ENDDO
!	PRINT *,'Met data read'

	OPEN (unit=12,FILE=inputstr//TRIM(ADJUSTL(blankedgridname)),status="old")		!FSA:	This is the glacier DEM
	OPEN (unit=13,FILE=inputstr//TRIM(ADJUSTL(basegridname)),status="old")
	CALL surf_read(giss_topography,gisstoponame)
	OPEN (unit=23,FILE=inputstr//TRIM(ADJUSTL(slopegridname)),status="unknown",IOSTAT=ios)
	IF (ios .NE. 0) THEN
	    PRINT *,"Run terran preprocessor before running pcebal"
	    STOP
	ENDIF
	OPEN (unit=24,FILE=inputstr//TRIM(ADJUSTL(aspectgridname)),status="unknown")
	OPEN (unit=28,FILE=inputstr//TRIM(ADJUSTL(meanhanglegridname)),STATUS="unknown")

	OPEN(UNIT=29,FILE=inputstr//TRIM(ADJUSTL(latsfilename)),STATUS="unknown")
	OPEN(UNIT=30,FILE=inputstr//TRIM(ADJUSTL(lonsfilename)),STATUS="unknown")

	DO i=1,2,1
	    READ(UNIT=(11+i),FMT='(4a)') header
	        IF (header.ne."DSAA") THEN
	        PRINT *,"DEM in wrong format"
	        STOP
	    END IF
	    READ(UNIT=(11+i),FMT=*) nlong,nlat
	    READ(UNIT=(11+i),FMT=*) xmin,xmax
	    READ(UNIT=(11+i),FMT=*) ymin,ymax
            READ(UNIT=(11+i),FMT='(4a)') trash
            !READ(UNIT=(11+i),FMT='(\)')

            READ(UNIT=(22+i),FMT='(4a)') header
	    IF (header.ne."DSAA") THEN
	        PRINT *,"DEM in wrong format"
	        STOP
	    END IF
	    READ(UNIT=(22+i),FMT=*) nlong,nlat
	    READ(UNIT=(22+i),FMT=*) xmin,xmax
	    READ(UNIT=(22+i),FMT=*) ymin,ymax
            READ(UNIT=(22+i),FMT='(4a)') trash
            !READ(UNIT=(22+i),FMT='(\)')
	END DO
	
	READ(UNIT=(28),FMT='(4a)') header
	IF (header.ne."DSAA") THEN
	    PRINT *,"DEM in wrong format"
	    STOP
	END IF
	READ(UNIT=(28),FMT=*) nlong,nlat
	READ(UNIT=(28),FMT=*) xmin,xmax
	READ(UNIT=(28),FMT=*) ymin,ymax
	READ(UNIT=(28),FMT='(4a)') trash
        !READ(UNIT=(28),FMT='(\)')
	READ(UNIT=(29),FMT='(4a)') header
	IF (header.ne."DSAA") THEN
	    PRINT *,"DEM in wrong format"
	    STOP
	END IF
	READ(UNIT=(29),FMT=*) nlong,nlat
	READ(UNIT=(29),FMT=*) xmin,xmax
	READ(UNIT=(29),FMT=*) ymin,ymax
	READ(UNIT=(29),FMT='(4a)') trash
        !READ(UNIT=(29),FMT='(\)')

	READ(UNIT=(30),FMT='(4a)') header
	IF (header.ne."DSAA") THEN
	    PRINT *,"DEM in wrong format"
	    STOP
	END IF
	READ(UNIT=(30),FMT=*) nlong,nlat
	READ(UNIT=(30),FMT=*) xmin,xmax
	READ(UNIT=(30),FMT=*) ymin,ymax
	READ(UNIT=(30),FMT='(4a)') trash
        !READ(UNIT=(30),FMT='(\)')

	DO i=1,nlat
	    READ(UNIT=12,FMT=*) (Gdem(i,j),j=1,nlong)
	    READ(UNIT=13,FMT=*) (Bdem(i,j),j=1,nlong)
	    READ(UNIT=23,FMT=*) (S(i,j),j=1,nlong,1)
	    READ(UNIT=24,FMT=*) (A(i,j),j=1,nlong,1)
	    READ(UNIT=28,FMT=*) (meanhangle(i,j),j=1,nlong,1)
        READ(UNIT=29,FMT=*) (latgrid(i,j),j=1,nlong,1)
        READ(UNIT=30,FMT=*) (longrid(i,j),j=1,nlong,1)
	END DO
	!Adjust the aspect grid by the angular distance from the central meridian.
	!CALL gridder(A,"test_aspect_in.grd")
	A=A-(107.+longrid)*3.14159267359/180.
	WHERE (A(:,:) .LT. -3.14159267359)
		A(:,:)=A(:,:)+2*3.14159267359
	ENDWHERE
	!CALL gridder(A,"test_aspect_out.grd")
	OPEN (UNIT=18,FILE=inputstr//TRIM(ADJUSTL(shadingfilename)),FORM="formatted",STATUS="old")
	DO k=1,36,1
		DO i=1,nlat,1
	        READ(UNIT=18,FMT='(700(f5.2,1x))',IOSTAT=ios) (shading(i,j,k),j=1,nlong,1)
	    END DO
	END DO
	CLOSE(UNIT=18)
	PRINT *,'line 148'

	CLOSE(UNIT=28)

	IF (model .EQ. 5) THEN
		inst_height=REAL(INT(ROUND(inst_height*100)))/100._dp
		WRITE(filenumber, FMT='(f4.2)') inst_height
		filename=inputstr//'turb_look_'//TRIM(ADJUSTL(filenumber))//'.dat'
		OPEN(UNIT=10,FILE=TRIM(ADJUSTL(filename)),STATUS='old')
		DO k=1,400,1
			DO i=1,80,1
				READ(UNIT=10,FMT='(200(g8.3,1x))') (trans_coeff(i,j,k),j=1,200,1)
			ENDDO
		ENDDO
		CLOSE(UNIT=10)
	
	roughindex=round(80._dp*(-LOG(zo_ice)-3._dp))
	trans_coeff_ice=trans_coeff(:,:,roughindex)
	roughindex=round(80._dp*(-LOG(zo_snow)-3._dp))
	trans_coeff_snow=trans_coeff(:,:,roughindex)
	DEALLOCATE(trans_coeff)
	
	ENDIF

	CLOSE(UNIT=25)
	CLOSE(UNIT=26)
	CLOSE(UNIT=12)
	CLOSE(UNIT=13)
	CLOSE(UNIT=23)
	CLOSE(UNIT=24)
	CLOSE(UNIT=27)
	CLOSE(UNIT=28)
	cell_size=(xmax-xmin)/(nlong-1)
	PRINT *,'loaded all data, back to ebalcode.f90'
END SUBROUTINE getdata
