SUBROUTINE gridder(grid,filename)
USE nrtype
USE params
!USE msflib
IMPLICIT NONE

REAL(DP),	DIMENSION(1:nlat,1:nlong),	INTENT(INOUT)	    :: grid

CHARACTER(LEN=*),				INTENT(IN   )	    :: filename

CHARACTER(LEN=30)						    :: numberstring1, &
								       numberstring2, &
								       numberstring3

INTEGER(I4B)							    :: i,j,ios


!*** Writes the content of a two dimensional grid to a surfer accessible file. Later versions may write
!*** ARC compatible ASCII files, but that's asking a lot...
!***
!*** This program assumes that the following are global variables:
!***	    nlat
!***	    nlong
!***	    xmin
!***	    xmax
!***	    ymin
!***	    ymax
!***
!*** To make this program as general as possible, the header information will be converted to strings
!*** for more precise control over the line length and character spacing, which are important
!*** in making output files directly readable by SURFER.

    OPEN(UNIT=101,FILE=outputstr//TRIM(ADJUSTL(filename)),STATUS="unknown",IOSTAT=ios)
    WRITE(UNIT=101,FMT='(4a)') "DSAA"
    WRITE(numberstring1,FMT='(i5)') nlong
    WRITE(numberstring2,FMT='(i5)') nlat
    numberstring3=TRIM(ADJUSTL(numberstring1))//" "//TRIM(ADJUSTL(numberstring2))
    WRITE(UNIT=101,FMT='(a30)') numberstring3
    WRITE(numberstring1,FMT='(i8)') INT(xmin)
    WRITE(numberstring2,FMT='(i8)') INT(xmax)
    numberstring3=TRIM(ADJUSTL(numberstring1))//" "//TRIM(ADJUSTL(numberstring2))
    WRITE(UNIT=101,FMT='(a30)') numberstring3
    WRITE(numberstring1,FMT='(i8)') INT(ymin)
    WRITE(numberstring2,FMT='(i8)') INT(ymax)
    numberstring3=TRIM(ADJUSTL(numberstring1))//" "//TRIM(ADJUSTL(numberstring2))
    WRITE(UNIT=101,FMT='(a30)') numberstring3
    WRITE(numberstring1,FMT='(g13.6)') MINVAL(grid(:,:))
    WHERE (grid(:,:) .GT. 1.e20)
	grid(:,:)=-9999._dp
    ENDWHERE
    WRITE(numberstring2,FMT='(g13.6)') MAXVAL(grid(:,:))
    numberstring3=TRIM(ADJUSTL(numberstring1))//" "//TRIM(ADJUSTL(numberstring2))
    WRITE(UNIT=101,FMT='(a30)') numberstring3

    WHERE (grid(:,:) .EQ. -9999._dp)
	grid(:,:)=blank
    ENDWHERE

    DO i=1,nlat,1
	WRITE(UNIT=101,FMT='(500(G13.6,1x))') (grid(i,j),j=1,nlong,1)
    ENDDO

    CLOSE(UNIT=101)

    ENDSUBROUTINE gridder
