#!/usr/bin/env python

import commands,os,sys,random,shutil
import timeit
import time
# import optparse to define command line options
from optparse import OptionParser

#The first order of business is to check to see if the terrain preprocessor needs to be run
#for the current resolution

		
		
		
def get_new_param(central_value,paramrange,logstat=0,gausstat=0):
	import math
	#minval=
	randnumber=random.random()

	if logstat != 1:
		minval=central_value-paramrange
		newparam=minval+2.*paramrange*randnumber	
		return(newparam)
	else:
		#For the log cases, the meanings of the inputs is different
		#Using the central value as the min and the range as the max.
		#sample in log space between these two then raise to power and return
		minval=math.log(central_value)
		maxval=math.log(paramrange)
		therange=maxval-minval
		newparm=minval+therange*randnumber
		newparm=math.exp(newparm)
		return(newparm)

def get_monte_outline():
	#build the outputline for the most recent monte carlo run
	paramsfile=open("Input/sensitivity_params.txt","r")
	params=paramsfile.readlines()
	paramsfile.close()
	mbalmiscfile=open("Output/massbal_misc.txt","r")
	mbalmisc=mbalmiscfile.readlines()
	mbalmiscfile.close()
	outline=""
	for param in params:
		outline=outline+param.strip('\n')+','
	#Now need to get the last net balance from the last line of the massbal_misc file
	eoybal=mbalmisc[len(mbalmisc)-1].split()
	eoybal=eoybal[0]
	outline=outline+eoybal+'\n'
	return(outline)


editor="/$home$/$editordirectory$/nedit"
#editor="emacs"

parser = OptionParser()

parser.add_option("-r","--res", dest="resolution", default="50", type="string",
				help="Enter the rsolution of grid in kms -- must be one of 10, 50 or 100", metavar="resolution")
parser.add_option("-f","--force-terrain", action="store_true", dest="terrainer", default=False,
				help="Use this option if you want to force terrain preprocessing", metavar="terrainer")
parser.add_option("-p","--params", action="store_true", dest="parameterizer", default=False, 
				help="Flick this flag if you want to edit the parameters file", metavar="parameterizer")
parser.add_option("-a","--all_params", action="store_true", dest="all_paramser", default=False, 
				help="Flick this flag if you want to edit the main parameters file", metavar="all_paramser")				
parser.add_option("-m","--monte_params", default=0,type="int",
				help="Run the monte carlo parameter estimation. The value will be the number of monte carlo runs. If it is set to zero then a single run will be conducted with the parameter values as given in the sensitivity_params.txt file.")

(options, args) = parser.parse_args()

laur_path="/$home$/$workingdirectory$/"

#Extract the input values into variables
resolution=str(options.resolution)
terrainer=float(options.terrainer)
parameterizer=float(options.parameterizer)
all_paramser=float(options.all_paramser)
monte_params=int(options.monte_params)

#If monte_params is anything but zero, have to override parameterizer and all_paramser to false
if monte_params > 0 :
	#We have to set parameterizer and all_paramser to zero
	parameterizer=0.
	all_paramser=0.


#With the resolution, read in the parameters file and replace the first line with the resolution
paramsfile=open(laur_path+"Input/param2d.txt","rw")
params=paramsfile.readlines()
paramsfile.close()
resline=params[0].split('\t')
resline[0]=resolution
outparams=open(laur_path+"Input/param2d.txt","w")
outparams.write(resline[0]+"\t"+resline[len(resline)-1])
outparams.writelines(params[1:len(params)+1])
outparams.close()

if parameterizer:
	commandstring=editor+" "+laur_path+"Input/sensitivity_params.txt"
	null=commands.getoutput(commandstring)
	print null
if all_paramser:
	commandstring=editor+" "+laur_path+"Input/param2d.txt"
	null=commands.getoutput(commandstring)
	commandstring=editor+" "+laur_path+"Input/sensitivity_params.txt"
	null=commands.getoutput(commandstring)
	print null	

#delete all the links for the current resolution in the Input directory
commandstring="rm -f "+laur_path+"Input/*.grd"
null=commands.getoutput(commandstring)
commandstring="rm -f "+laur_path+"Input/laur_21k*.dat"
null=commands.getoutput(commandstring)

#delete the files in the output directory
print "deleting all files in output directory!!!! -- sorry"
commandstring="rm -f "+laur_path+"Output/*.grd"
null=commands.getoutput(commandstring)
commandstring="rm -f "+laur_path+"Output/*.txt"
null=commands.getoutput(commandstring)

commandstring="make sterile && make terrain && make opt"
null=commands.getoutput(commandstring)
print null

#Check the existence of various terrain files
InputSourceDir="Input_"+resolution+"/"
commandstring="ls "+InputSourceDir+"laur_21k_slope_"+resolution+".grd"
print commandstring
null=commands.getoutput(commandstring)
splitout=null.split(" ")
if (len(splitout) == 1)  and (not terrainer):
	print "Terrain files exist -- assuming terrain processor does not need to be run"
	print "linking the terrain files to the working input directory."
	print "linking the lats and longs file to the working input directory"
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_"+resolution+".grd "+laur_path+"Input/." 
	null=commands.getoutput(commandstring)
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_"+resolution+"_base.grd "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_lats_"+resolution+".grd "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_lons_"+resolution+".grd "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_shading_"+resolution+".dat "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_aspect_"+resolution+".grd "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_slope_"+resolution+".grd "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_meanhangle_"+resolution+".grd "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/giss_topo_"+resolution+".grd "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
			
elif (splitout[0] == "ls:" and (resolution == str(50) or resolution == str(25) or resolution == str(10) or resolution == str(5))) or terrainer:
	print "!!Forcing run of the terrain preprocessor!!"
	#have to move the required inputs to the terrain_calc input folder.
	#These are the dem, the base dem, the lat grids, and the lon grids. The latter two don't come into play, but
	#should be present due to shared inputting files
	#use symbolic linking to do this work:
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_"+resolution+".grd "+laur_path+"Input/." 
	null=commands.getoutput(commandstring)
	print commandstring
	print null
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_"+resolution+"_base.grd "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
	print commandstring
	print null
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_lats_"+resolution+".grd "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
	print null
	commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_lons_"+resolution+".grd "+laur_path+"Input/."
	null=commands.getoutput(commandstring)
	print commandstring
	print null
	commandstring=laur_path+"trancalc.x"
	null=commands.getoutput(commandstring)
	print null
	splitnull=null.split(' ')
	if splitnull[1] != "laps:":
		#Command files
		print "Execution of terrain failed better check it out"
		sys.exit()
	else:
		print "terrain successful, linking files and running model."
		#Move the output grids to the appropriate input for the resolution
		#Also have to link these grids in the working input directory.
		commandstring="mv "+laur_path+"Input/laur_21k_shading_"+resolution+".dat "+laur_path+"Input_"+resolution+"/laur_21k_shading_"+resolution+".dat"
		null=commands.getoutput(commandstring)
		commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_shading_"+resolution+".dat "+laur_path+"Input/."
		null=commands.getoutput(commandstring)
		commandstring="mv "+laur_path+"Output/laur_21k_aspect_"+resolution+".grd "+laur_path+"Input_"+resolution+"/laur_21k_aspect_"+resolution+".grd"
		null=commands.getoutput(commandstring)
		commandstring="mv "+laur_path+"Output/laur_21k_slope_"+resolution+".grd "+laur_path+"Input_"+resolution+"/laur_21k_slope_"+resolution+".grd"
		null=commands.getoutput(commandstring)
		commandstring="mv "+laur_path+"Output/laur_21k_meanhangle_"+resolution+".grd "+laur_path+"Input_"+resolution+"/laur_21k_meanhangle_"+resolution+".grd"
		null=commands.getoutput(commandstring)
		commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_aspect_"+resolution+".grd "+laur_path+"Input/."
		null=commands.getoutput(commandstring)
		commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_slope_"+resolution+".grd "+laur_path+"Input/."
		null=commands.getoutput(commandstring)
		commandstring="ln -sf "+laur_path+"Input_"+resolution+"/laur_21k_meanhangle_"+resolution+".grd "+laur_path+"Input/."
		null=commands.getoutput(commandstring)
		commandstring="ln -sf "+laur_path+"Input_"+resolution+"/giss_topo_"+resolution+".grd "+laur_path+"Input/."
		null=commands.getoutput(commandstring)
		
		
	
else:
	print "bogus filename -- only have input data for resolutions of 10, 50, and 100 kms"
	#Need to insert command to stop script
	sys.exit()

#So, done with all the terrain BS. Now it's time to run the model.  
#First want to link all the input grids into the working Input directory
commandstring="ln -sf "+laur_path+"Input_"+resolution+"/giss_laur*"+resolution+".grd "+laur_path+"Input/."
null=commands.getoutput(commandstring)


print monte_params
if monte_params == 0:
	#Now run the model -- woo hoo!!!
	commandstring=laur_path+"ebal.x"
	null=commands.getoutput(commandstring)
	print null
else:
	#Running the model in monte carlo parameter selection mode. the sensit params will be 
	#vaired at random according to the parameter ranges stored in the monte_carlo_ranges.txt file.
	#The value of monte_params is the number of runs that will be taken. Parameter values will be selected from
	#A uniform distribution about the central value in the sensitivity_params.txt file. For the roughness parameters, this 
	#range will be in logrythmic space.
	
	print "Running monte carlo parameter variation for: "+str(monte_params)+" runs.\nThis will take, roughly, "+str(1.3333333*monte_params)+" minutes to complete (timing may vary with resolution and computer power)."
	print "This will overwrite your existing sensitivity params file."
	backupstat = raw_input("Would you like to save a backup? y for yes!")
	backupstat=backupstat.strip()
	if backupstat=='y':
		shutil.copy("Input/sensitivity_params.txt","Input/sensitivity_params.txt.backup")
	else:
		nullstat=raw_input("Over-writing your sensitivity params file. Hit enter to continue or control + C to stop")
	
	#edit the monte carlo ranges file
	commandstring=editor+" "+laur_path+"Input/monte_carlo_ranges.csv"
	null=commands.getoutput(commandstring)
	print null
	
	
	#Open up the input and output files
	
	monte_outfile = open("Output/monte_carlo_output.csv","w")
	monte_outfile.write("zo_i,zo_s,tlaps,plaps,Hvap,trans,a_terr,d_dec_s,a_dec_i,a_min_s,a_max_s,a_min_i,ELA_slope,ELA45,netbal\n")
	rangesfile = open("Input/monte_carlo_ranges.csv","r")
	ranges = rangesfile.readlines()
	rangesfile.close()
	#Skip the first two header lines and the last
	ranges=ranges[2:]
	for monterun in range(1,monte_params+1) :
		paramsfile = open("Input/sensitivity_params.txt","w")
		#First two are the surface roughness lengths.  Need to take the range and convert it into
		#log space to sample between
		for lineidx,paramline in enumerate(ranges):
			paramline=paramline.split(',')
			if 'roughness' in paramline[2]:
				#Have the roughness parameters so need to 
				#handle these in log space
				outparam=get_new_param(float(paramline[0]),float(paramline[1]),1)
			else:
				#Normal parameters. Select uniformly about the central value within the range.
				outparam=get_new_param(float(paramline[0]),float(paramline[1]),0)
			paramsfile.write(str(outparam)+"\n")
		paramsfile.close()
		
		# next 2 lines are for saving out multiple eoy_balance and total_ablation files.  Comment out if not needed.
		commandstring="cp Output/eoy_balance.grd Output/eoy_balance"+str(monterun-1)+".grd"
		null=commands.getoutput(commandstring)
		#commandstring="cp Output/total_ablation.grd Output/total_ablation"+str(monterun-1)+".grd"
		#null=commands.getoutput(commandstring)
		#commandstring="cp Output/total_refreezing.grd Output/total_refreezing"+str(monterun-1)+".grd"
		#null=commands.getoutput(commandstring)
		
		print "Working on run #"+str(monterun)
		the_start = time.time()
		
		#Now we can run the mass balance model and pull out the parameters and the mass balance and stick it in the
		#monte carlo output file.
		#Now run the model -- woo hoo!!!
		commandstring=laur_path+"ebal.x"
		null=commands.getoutput(commandstring)
		print null
		outline=get_monte_outline()
		monte_outfile.write(outline)
		## next 2 lines are for saving out multiple eoy_balance and total_ablation files.  Comment out if not needed.
		#commandstring="cp Output/eoy_balance.grd Output/eoy_balance"+str(range)+".grd"
		#commandstring="cp Output/total_ablation.grd Output/total_ablation"+str(range)+".grd"
		the_end = time.time()
		elapsed_time = the_end - the_start
		print "elapsed time = "+str(elapsed_time)+" seconds"
	monte_outfile.close()
		
		

		
	
	
	
