SUBROUTINE lwcalc(modelday,atemp,dt,terrainview,skyview,avp,linmet,cloud,stemp,Lnet,lin)
USE nrtype
USE params
IMPLICIT NONE

	INTEGER(I4B),			INTENT(IN   )							:: modelday
	REAL(DP),				INTENT(IN   )							:: atemp, &
																	   dt, &
							   										   skyview, &
							   										   terrainview, &
																	   avp, &
							   										   linmet
	REAL(DP),				INTENT(IN   ),	DIMENSION(met_length)	:: cloud
	REAL(DP),				INTENT(IN   )							:: stemp
	REAL(DP),				INTENT(  OUT)							:: Lnet
	REAL(DP),				INTENT(  OUT)							:: lin					   	
	
	REAL(DP)														:: clsky, &
																	   emiss, &
																	   emiss0, &
																	   inlwrad, &
																	   rad1, &
																	   rad2, &
																	   tlwrad, &
																	   drad, &
																	   outlwrad





	IF (tmstp .LT. 86400) THEN !Hourly or	finer time step in use	
		IF (lin_stat) THEN
			!there is a longwave record in the met file
			tlwrad=stef_bolz*0.95*((atemp)**4)
			Lin=(linmet*(skyview)+tlwrad*terrainview)
			Lnet=Lin-(ice_emiss*stef_bolz*(Stemp**4))
		ELSE		!For metfiles without lin, set values equal to -6999
			clsky=8.733e-3*(atemp**0.788)
			emiss=(1.+0.26*cloud(modelday))*clsky	
			inlwrad=stef_bolz*emiss*(atemp**4)!atmospheric LWR
			tlwrad=stef_bolz*0.95*(atemp**4)!terrain LWR 5-2-99
			!c adjust for view factor via Dozier and Outcalt, 1979;
			!c  Marks and Dozier, 1979 (eq.8,9)
			inlwrad=inlwrad*skyview
			tlwrad=tlwrad*terrainview
			Lin=inlwrad+tlwrad
			Lnet=Lin-(ice_emiss*stef_bolz*(Stemp**4))
		ENDIF
	ELSE IF (tmstp .EQ. 86400) then !adjust Lin for lapse rate & skyview
		IF (lin_stat) THEN
            emiss0=(0.66+0.039*sqrt(avp/10.))
            emiss=DMIN1(1.0_dp,emiss0)
		    !cswh   adjust lw for temp perturbation
            rad1=stef_bolz*emiss*((atemp-dt)**4)
            rad2=stef_bolz*emiss*((atemp)**4)
            drad=(rad2-rad1)
            Lin=Linmet+drad
            tlwrad=(stef_bolz*0.95_dp*(atemp**4))*terrainview	!Incoming LW from surrounding terrain.
            inlwrad=(Lin)*skyview+tlwrad				!INcoming LW from the sky
            outlwrad=ice_emiss*stef_bolz*(Stemp**4)
            Lnet=inlwrad-outlwrad
		ELSE
			clsky=8.733e-3*(atemp**0.788)
			emiss=(1.+0.26*cloud(modelday))*clsky	
			inlwrad=stef_bolz*emiss*(atemp**4)!atmospheric LWR
			tlwrad=stef_bolz*0.95*(atemp**4)!terrain LWR 5-2-99
			!c adjust for view factor via Dozier and Outcalt, 1979;
			!c  Marks and Dozier, 1979 (eq.8,9)
			inlwrad=inlwrad*skyview
			tlwrad=tlwrad*terrainview
			Lin=inlwrad+tlwrad
			Lnet=Lin-(ice_emiss*stef_bolz*(Stemp**4))		
		ENDIF
	ENDIF


END SUBROUTINE lwcalc
