SUBROUTINE meanhangles(shading,gdem,S,A,meanhangle)
USE params
USE nrtype
IMPLICIT NONE

REAL(DP),	DIMENSION(1:nlat,1:nlong,1:36),	INTENT(IN   )	:: shading
REAL(DP),	DIMENSION(1:nlat,1:nlong),		INTENT(IN   )	:: gdem, &
															   S, &
															   A
REAL(DP),	DIMENSION(1:nlat,1:nlong),		INTENT(  OUT)	:: meanhangle

REAL(DP),	DIMENSION(1:36)									:: azims, &
															   shade_cell

REAL(DP)													:: cos_slope, &
															   sin_slope
															   
INTEGER(I4B)												:: i,j

!**************************************************************************************
!***	Here's the Dozier and Frew aproach to calculating the view factor. This 
!***	includes the viewablity of the surrounding terrain as modified by changes in 
!***	surface slope as above, but actually correct!!
!***************************************************************************************


	azims(1:36)=(/(j,j=10,360,10)/)
	meanhangle(:,:)=0._dp
	DO i=1,nlat,1
		DO j=1,nlong,1
			IF (gdem(i,j) .LT. blank) THEN
				cos_slope=COS(S(i,j))
				sin_slope=SIN(S(i,j))
				shade_cell=(pi/2._dp)-shading(i,j,:)
				meanhangle(i,j)=SUM(cos_slope*SIN(shade_cell)**2+sin_slope* &
					COS(azims(:)-A(i,j))*(shade_cell(:)-SIN(shade_cell(:))* &
					COS(shade_cell(:))))
			END IF
		ENDDO
	ENDDO	
	meanhangle(:,:)=meanhangle(:,:)/(36._dp)
	
END SUBROUTINE meanhangles
