SUBROUTINE stakestats(var,stakebal,stkheader,modelstkbal,massbal,cellnum)
USE nrtype
USE params
IMPLICIT NONE


	REAL(DP),	DIMENSION(1:met_length,ninsts),		INTENT(IN   )				:: var
	REAL(DP),	DIMENSION(10,2,numstk),				INTENT(IN   )				:: stakebal
	REAL(DP),	DIMENSION(1:(2*numstk)),			INTENT(IN   )				:: stkheader
	REAL(DP),	DIMENSION(1:met_length,1:numstk),	INTENT(IN   )				:: modelstkbal
	REAL(DP),	DIMENSION(nlat,nlong,nlayers),		INTENT(IN   )				:: massbal
	
	INTEGER(I4B),									INTENT(IN   )				:: cellnum
	
	REAL(DP),	DIMENSION(10*numstk,4)											:: mod_vs_meas, &
																				   space
	REAL(DP)																	:: rmse

	INTEGER(I4B),	DIMENSION(1:200)			:: sort_indexes
	INTEGER(I4B)																:: i, &
																				   j, &
																				   total_stakemeas, &
																				   dateindex, &
																				   round, &
																				   count

	CHARACTER(LEN=5)															:: filenumber
	CHARACTER(LEN=30) 															:: filename



!***************************************************************************************************
!**		Lets calculate some stake statistics now. Calculating the chi square between the measured 
!**		modelled ablation rates.
!**		so, the first job is to pull out modelled ablation values. Then calculate differences. Then
!**		the chi square.
!***************************************************************************************************
	mod_vs_meas=0._dp
	space=0._dp
	total_stakemeas=0
	DO i=1,numstk,1
		DO j=1,INT(stkheader(i*2)),1
			total_stakemeas=total_stakemeas+1
			IF (tmstp .LT. 86400) THEN
				dateindex=INT(FLOOR(((stakebal(j,1,i)-(var(1,1)-excel_date))/(1._dp/24._dp))+1._dp))
				IF (dateindex .GT. met_length) dateindex=met_length
			ELSE
				dateindex=round(stakebal(j,1,i)-(var(1,1)-excel_date))
			ENDIF
			mod_vs_meas(total_stakemeas,1)=modelstkbal(dateindex,i)
			mod_vs_meas(total_stakemeas,2)=stakebal(j,2,i)		
			IF (j .GT. 1) THEN
				mod_vs_meas((total_stakemeas),3)=mod_vs_meas((total_stakemeas-1),1)-mod_vs_meas(total_stakemeas,1)
				mod_vs_meas((total_stakemeas),4)=mod_vs_meas((total_stakemeas-1),2)-mod_vs_meas(total_stakemeas,2)
			ELSE
				mod_vs_meas(total_stakemeas,3)=0
				mod_vs_meas(total_stakemeas,4)=0
			ENDIF
		ENDDO
	ENDDO
	IF (numstk .GT. 0) THEN
		!	Sort the stake measurements
		CALL indexx(total_stakemeas,mod_vs_meas(1:total_stakemeas,4),sort_indexes(1:total_stakemeas))
		space(:,:)=mod_vs_meas(:,:)
		mod_vs_meas=0._dp
		
		count=0
		DO i=total_stakemeas,1,-1
			IF ((space(sort_indexes(i),4) .LT. -0.01) .OR. (space(sort_indexes(i),4) .GT. 0.01)) THEN
				count=count+1
				mod_vs_meas(count,:)=space(sort_indexes(i),:)
			ELSE
				CONTINUE
			ENDIF
		ENDDO	
		
		
		rmse=(SUM((mod_vs_meas(1:count,3)-mod_vs_meas(1:count,4))**2)/count)**0.5
		WRITE(filenumber,FMT='(i5)') runnumber
		filename="chi_data_"//TRIM(ADJUSTL(filenumber))//".dat"
		OPEN(UNIT=99,form="formatted",file=outputstr//filename)
		WRITE(UNIT=99,FMT='(i4,1x,f8.5,1x,f8.6,1x,f8.6,1x,f8.6,1x,f8.6,1x,f6.3,1x,f6.3,7(1x,f8.4))') &
				runnumber,rmse,laps,pre_laps,zo_ice,zo_snow,trans,terrain_albedo, &
				a_decay,a_decay_ice,SUM(massbal(:,:,:))/cellnum,modelstkbal(met_length,1), &
				modelstkbal(met_length,3),modelstkbal(met_length,5)
		WRITE(UNIT=99,FMT='("model  measur modmlt mesmlt ",1x,f8.5)') rmse
		DO i=1,total_stakemeas,1
			WRITE(UNIT=99,FMT='(4(f6.3,1x))') (space(i,j),j=1,4,1)
		ENDDO
		CLOSE(UNIT=99)
	ENDIF
!*************************************************************************************************************
END SUBROUTINE stakestats

